//+------------------------------------------------------------------+
//|                                         Elder Impulse System.mq4 |
//|                              Copyright  2010, K. S. Podkorytoff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, K. S. Podkorytoff"
#property indicator_chart_window

#property indicator_buffers 6

#property indicator_color1 SeaGreen
#property indicator_color2 SeaGreen
#property indicator_color3 Crimson
#property indicator_color4 Crimson
#property indicator_color5 SkyBlue
#property indicator_color6 SkyBlue

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2 

//----  
extern string _EMA_externs_____________="____________ value ____________";
extern int EMA_period=13;
extern string _MACD_Hist_externs_______="____________ value ____________";
extern int fast_ema_period=8;
extern int slow_ema_period=18;
extern int signal_sma_period=9;
extern string _High_Low_or_Open_Close__="____________ value ____________";
extern int HL_or_OC=2;
//---- 
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

//------------------------------------------------------+
int init()
  {
//----    
   SetIndexBuffer(0,ExtMapBuffer1);   
   SetIndexBuffer(1,ExtMapBuffer2);   
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);   
   SetIndexBuffer(4,ExtMapBuffer5);   
   SetIndexBuffer(5,ExtMapBuffer6);   
//----       
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexStyle(2,DRAW_HISTOGRAM); 
   SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexStyle(4,DRAW_HISTOGRAM); 
   SetIndexStyle(5,DRAW_HISTOGRAM); 
   return(0);
  }
//----------------------------------------------------+
int deinit()
{
   return(0);
}
//--------------------------------------------------------------+ 
int start()
  {
   int i,limit,counted_bars=IndicatorCounted();
   double top, bot;
//----
   i=Bars-counted_bars-1;
   while(i>=0)  
      {
         //----    
         double MA_0=iMA(NULL,0,EMA_period,0,MODE_EMA,PRICE_CLOSE,i);     //  EMA
         double MA_1=iMA(NULL,0,EMA_period,0,MODE_EMA,PRICE_CLOSE,i+1);   //  EMA
         //----    MACD
         double MACD_main1 = iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_sma_period,PRICE_CLOSE,MODE_MAIN,i);       //MACD
         double MACD_signal1 = iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_sma_period,PRICE_CLOSE,MODE_SIGNAL,i);   // 
         //----    MACD
         double MACD_main2 = iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_sma_period,PRICE_CLOSE,MODE_MAIN,i+1);     //MACD
         double MACD_signal2 = iMACD(NULL,0,fast_ema_period,slow_ema_period,signal_sma_period,PRICE_CLOSE,MODE_SIGNAL,i+1); // 
         //----       open  close   high  low) 
         switch(HL_or_OC)
            {
               case 1:   
                  top=High[i];
                  bot=Low[i];
               break;
               case 2:
                  top=MathMax(Open[i],Close[i]);
                  bot=MathMin(Open[i],Close[i]); 
               break;
            }                     
         //----   
         if(MA_0>MA_1 && (MACD_main1-MACD_signal1)>(MACD_main2-MACD_signal2))
            {
            ExtMapBuffer1[i]=top;
            ExtMapBuffer2[i]=bot;
            }
         if(MA_0<MA_1 && (MACD_main1-MACD_signal1)<(MACD_main2-MACD_signal2))
            {
            ExtMapBuffer3[i]=top;
            ExtMapBuffer4[i]=bot;
            } 
         if(MA_0<=MA_1 && (MACD_main1-MACD_signal1)>=(MACD_main2-MACD_signal2))
            {
            ExtMapBuffer5[i]=top;
            ExtMapBuffer6[i]=bot;
            } 
         if(MA_0>=MA_1 && (MACD_main1-MACD_signal1)<=(MACD_main2-MACD_signal2))
            {
            ExtMapBuffer5[i]=top;
            ExtMapBuffer6[i]=bot;
            }                                                      
         i--;
      } 
//----
   return(0);
  }